// Generated by CoffeeScript 1.10.0
(function() {
  var Component, PropTypes, Provider, connect, createStore, isobject, provider, ref, storeShape,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ref = require('react'), Component = ref.Component, PropTypes = ref.PropTypes;

  provider = null;

  isobject = function(o) {
    return !!o && typeof o === 'object' && !Array.isArray(o);
  };

  createStore = function(state) {
    var dispatch, dispatching, getState, listeners, setState, subscribe;
    listeners = [];
    subscribe = function(listener) {
      var isSubscribed, unsubscribe;
      isSubscribed = true;
      listeners.push(listener);
      return unsubscribe = function() {
        var index;
        if (!isSubscribed) {
          return;
        }
        isSubscribed = false;
        index = listeners.indexOf(listener);
        return listeners.splice(index, 1);
      };
    };
    setState = function(newstate) {
      var prevstate;
      prevstate = state;
      state = newstate;
      return listeners.forEach(function(l) {
        return l(state, prevstate);
      });
    };
    getState = function() {
      return state;
    };
    dispatching = false;
    dispatch = function(action) {
      var err, error, k, newstate, newval, v;
      if (dispatching) {
        throw new Error("dispatch in dispatch is not allowed");
      }
      dispatching = true;
      try {
        newval = action(state, dispatch);
      } catch (error) {
        err = error;
        throw err;
      } finally {
        dispatching = false;
      }
      if (!isobject(newval)) {
        throw new Error("Action must return an object");
      }
      for (k in newval) {
        v = newval[k];
        if (!state.hasOwnProperty(k)) {
          throw new Error("Action returned key (" + k + ") missing in state");
        }
      }
      newstate = Object.assign({}, state, newval);
      return setState(newstate);
    };
    return {
      subscribe: subscribe,
      dispatch: dispatch,
      getState: getState
    };
  };

  Provider = (function(superClass) {
    extend(Provider, superClass);

    function Provider(props) {
      this.componentWillUnmount = bind(this.componentWillUnmount, this);
      this.componentDidMount = bind(this.componentDidMount, this);
      Provider.__super__.constructor.apply(this, arguments);
      if (props.children) {
        throw new Error("Provider does not support children");
      }
      this.store = props.store;
      this.app = props.app;
      this.state = props.store.getState();
    }

    Provider.prototype.componentDidMount = function() {
      return this.unsubscribe = this.store.subscribe((function(_this) {
        return function(newstate) {
          return _this.setState(newstate);
        };
      })(this));
    };

    Provider.prototype.componentWillUnmount = function() {
      if (typeof this.unsubscribe === "function") {
        this.unsubscribe();
      }
      return this.unsubscribe = null;
    };

    Provider.prototype.render = function() {
      var err, error;
      provider = this;
      try {
        return this.app();
      } catch (error) {
        err = error;
        throw err;
      } finally {
        provider = null;
      }
    };

    return Provider;

  })(Component);

  storeShape = PropTypes.shape({
    subscribe: PropTypes.func.isRequired,
    dispatch: PropTypes.func.isRequired,
    getState: PropTypes.func.isRequired
  });

  Provider.propTypes = {
    app: PropTypes.func.isRequired,
    store: storeShape.isRequired
  };

  connect = function(viewfn) {
    return function() {
      var dispatch, state;
      if (!provider) {
        throw new Error("No provider in scope. View function outside Provider?");
      }
      state = provider.store.getState();
      dispatch = provider.store.dispatch;
      return viewfn(state, dispatch);
    };
  };

  module.exports = {
    createStore: createStore,
    Provider: Provider,
    connect: connect
  };

}).call(this);

//# sourceMappingURL=refnux.js.map
